<?php
/**
 * Plugin Name: latest_posts
 * Description: A Widget will display your latest_posts in your sidebar . 
 * Version: 0.1
 * Author: Melnik	
 * Author URI: http://melnik.xe0.ru
 */

add_action( 'widgets_init', 'latest_posts' );// Загрузка виджета

// Функция регистрации виджета
function latest_posts() {
	register_widget( 'MY_Widget_latest_posts' );
}

//Класс виджета
class MY_Widget_latest_posts extends WP_Widget {
// Установки виджета
	function MY_Widget_latest_posts() {
		$widget_ops = array( 'classname' => 'portfolio', 'description' => __('A Widget will display your latest_posts in your sidebar ', 'portfolio') );
		
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'portfolio-widget' );
		
		$this->WP_Widget( 'portfolio-widget', __('latest_posts Widget', 'portfolio'), $widget_ops, $control_ops );
	}
// Вывод виджета	
	function widget( $args, $instance ) {
		extract( $args );

		//Our variables from the widget settings.
		$title = apply_filters('widget_title', $instance['title'] );
		$count = $instance['count'];

		echo $before_widget;
		// Display the widget title 
		if ( $title )
			echo $before_title . $title . $after_title;

		//Display the count 
		if ( $count )
global $post;
 $interval = date('Y-m-d', strtotime("-$period days"));
 $result = new WP_Query(array( 'category_name' => 'blog','showposts'=>$count ) );
 while ($result -> have_posts()) : $result -> the_post();
 ?>
 <div class="widgetlastpost">
  <div class="imgpost">
 <?php
 if ( has_post_thumbnail()) { ?>
   <a href="<?php  the_permalink(); ?>" title="<?php  the_title_attribute(); ?>" > <?php  the_post_thumbnail(array(100,70)); ?> </a>
 <?php  } else{ echo get_post_image();} ?>
</div>
<p><?php  echo mb_substr(strip_tags(get_the_content()),0,110); ?></p>

<span style="float:right;"><a href="<?php the_permalink();?>">Далее...</a></span>


 </div>
 <?php endwhile; wp_reset_postdata(); 
 
	echo $after_widget;
	}

//Обновление виджета Данная функция получает установки пользователя и сохраняет их.	 
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		//Strip tags from title and count to remove HTML 
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['count'] = strip_tags( $new_instance['count'] );

		return $instance;
	}

//Здесь пользователь будет определять установки и значения	
	function form( $instance ) {

		//Set up some default widget settings.
		$defaults = array( 'title' => __('Example', 'portfolio'), 'count' =>'3' , 'portfolio');
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

<?//Widget Title: Text Input.?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'portfolio'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>

<?//Text Input.?>
		<p>
			<label for="<?php echo $this->get_field_id( 'count' ); ?>"><?php _e('count post', 'portfolio'); ?></label>
			<input id="<?php echo $this->get_field_id( 'count' ); ?>" name="<?php echo $this->get_field_name( 'count' ); ?>" value="<?php echo $instance['count']; ?>" style="width:100%;" />
		</p>

	<?php
	}
}

?>